#vider la mmoire
rm(list=ls())

#*********************************************
#modifier le rpertoire et charger les donnes
#*********************************************
setwd(... mettre rpertoire de travail ici ...)
conso <- read.csv(file="conso_vehicules.csv",sep=";")
conso #vrification

#rgression linaire multiple                     layout(
reg <- lm(y ~ prix + cylindree + puissance + poids, conso)
summary(reg) #afficher les rsultats

#lister les attributs de l'objet reg
attributes(reg)
#rcuprer les rsidus
e <- reg$residuals

#droite de Henry, attention R conserve les quantiles normaliss en ordonne
qqnorm(e,datax=TRUE,ylab="Quantiles observs",xlab="Quantiles thoriques normalises")

#graphiques des rsidus
plot(conso$y,e,ylab="Rsidus",main="Rsidus vs. Endogne")
abline(0,0)
plot(conso$prix,e,ylab="Rsidus",main="Rsidus vs. Exogne")
abline(0,0)
plot(conso$cylindree,e,ylab="Rsidus",main="Rsidus vs. Exogne")
abline(0,0)
plot(conso$puissance,e,ylab="Rsidus",main="Rsidus vs. Exogne")
abline(0,0)
plot(conso$poids,e,ylab="Rsidus",main="Rsidus vs. Exogne")
abline(0,0)

#librairie fBasics
library(fBasics)
jarqueberaTest(e) #test de Jarque-Bera, attention au degr de libert diffrent

#boxplot de l'endogne
boxplot(conso$y)

#boxplot des exognes
boxplot(conso$prix)
boxplot(conso$cylindree)
boxplot(conso$puissance)
boxplot(conso$poids)

#dtection des points atypiques et influents
atypiques <- influence.measures(reg)
atypiques

#calcul du rsidu standardis
res.standard <- rstandard(reg)

#construction du graphique des rsidus standardiss
plot(conso$y,res.standard)
abline(-1.7056,0)
abline(1.7056,0)
abline(0,0)

#mettre en vidence les points atypiques
text(conso$y[25],res.standard[25]-0.2,"Mitsubishi Galant")
text(conso$y[9],res.standard[9]+0.2,"Mercedes S600")
text(conso$y[8]-0.2,res.standard[8]-0.2,"Ferrari 456 GT")
text(conso$y[22],res.standard[22]-0.2,"Hyundai Sonata")
 
#calcul du rsidu studentis
res.student <- rstudent(reg)

#construction du graphique
plot(conso$y,res.student)
abline(-1.7081,0)
abline(1.7081,0)
abline(0,0)

#************************************
#supprimer les observations atypiques
#************************************
conso <- conso[c(-8,-9,-10,-25),]

#**********************
#slection de variables
#********************** 

#rgression linaire multiple
reg <- lm(y ~ prix + cylindree + puissance + poids, conso)
summary(reg) #afficher les rsultats

#calculer la matrice des corrlations croises
mcxx <- cor(conso[,c(2,3,4,5)])
mcxx #affichage

#calculer les corrlations entre Y et X_j
mcyx <- cor(conso[,c(2,3,4,5)],conso[,6])
mcyx #affichage

#slection de modle par minimisation de l'AIC
library(MASS)

#recherche backward
reg <- lm(y ~ prix + cylindree + puissance + poids, conso)
stepAIC(reg,trace=TRUE,direction="backward")

#recherche forward
reg <- lm(y ~ 1,data=conso)
stepAIC(reg,scope=list(upper=~prix+cylindree+puissance+poids,lower=~1),direction="forward",trace=TRUE)

