#vider la mmoire
rm(list=ls())

#*********************************************
#modifier le rpertoire et charger les donnes
#*********************************************
setwd(... mettre rpertoire de travail ici ...)
fichier <- read.csv(file="chow.csv",sep=";")
fichier #vrification

#modle initial pour SCR
reg <- lm(y ~ x,data = fichier)
scr <- sum(reg$residuals^2)
scr

#************
#test de Chow
#************

#modle pour SCR1
fichier1 <- fichier[fichier$periode == 1,]
reg1 <- lm(y ~ x,data = fichier1)
scr1 <- sum(reg1$residuals^2)
scr1

#modle pour SCR2
fichier2 <- fichier[fichier$periode == 2,]
reg2 <- lm(y ~ x,data = fichier2)
scr2 <- sum(reg2$residuals^2)
scr2

#degrs de libert
ddl_n <- (reg$df.residual - (reg1$df.residual + reg2$df.residual))
ddl_d <- reg1$df.residual + reg2$df.residual

#F du test de Chow et p-value
FChow <- ((scr-(scr1+scr2))/ddl_n)/((scr1+scr2)/ddl_d)
FChow

pvalue <- pf(FChow,ddl_n,ddl_d,lower.tail=FALSE)
pvalue

#********************
#test de la constante
#********************

#construire les variables d1 et d2
d1 <- c(1,0)[fichier$periode]
d2 <- c(0,1)[fichier$periode]

#rgression sans constante pour SCR3
reg3 <- lm(y ~ 0 + x + d1 + d2, data = fichier)
scr3 <- sum(reg3$residuals^2)
scr3

#ddl
ddl_n = reg$df.residual - reg3$df.residual
ddl_d = reg3$df.residual

#F et p-value
FTest <- ((scr-scr3)/ddl_n)/(scr3/ddl_d)
FTest

pvalue <- pf(FTest,ddl_n,ddl_d,lower.tail=FALSE)
pvalue

#****************
#test de la pente
#****************

#construire les variables z1 et z2
z1 <- d1 * fichier$x
z2 <- d2 * fichier$x

#rgression sans constante pour SCR4
reg4 <- lm(y ~ 0 + z1 + z2 + d1 + d2, data = fichier)
scr4 <- sum(reg4$residuals^2)
scr4

#ddl
ddl_n = reg3$df.residual - reg4$df.residual
ddl_d = reg4$df.residual

#F et p-value
FTest <- ((scr3-scr4)/ddl_n)/(scr4/ddl_d)
FTest

pvalue <- pf(FTest,ddl_n,ddl_d,lower.tail=FALSE)
pvalue

